(ns org.aplex.stability-ai.core
  (:require [org.aplex.helpers.interface :as h])
  )

(def api-config (atom {:api-host "https://api.stability.ai"
                       :api-key "STABILITY_API_KEY"}))

(def api-host "https://api.stability.ai")
(def api-key "sk-t8dmTcOV2jOAALqJ4yjS8qEOgr4NZHumuHd3ppuMsQn9os2W")

(def default-authed-payload {:headers {"Authorization" (str "Bearer " api-key)
                                       "content-type" "application/json"}})

(defn init-config [cfg]
  (reset! api-config (merge @api-config cfg)))

(defn build-url [path]
  (str api-host path))

(defn fetch-user-account []
  (merge default-authed-payload 
         {:url (build-url "/v1/user/account")
          :handler prn}))

(defn fetch-user-balance []
  (merge default-authed-payload 
         {:url (build-url "/v1/user/balance")
          :handler prn}))

(defn fetch-generation-text-to-image []
  (merge default-authed-payload 
         {:url (build-url "/v1/user/balance")
          :format :json
          :response-format :json
          :params {:text_prompts [{:text "A wooden hand crafted light house"
                                   :weight 0.5}]}
          :handler prn}))


